#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "matrix.h"

int size, range;
double **matrixA, **matrixB, **matrixProduct;

double radom(){
	return ((double) rand() / RAND_MAX) * 100.0;
}

double **create_matrix(){
	int line;
	double **matrix;
	matrix = (double**) malloc (DIMENSION * sizeof(double*));

	for (line = 0; line < DIMENSION; line++){
		matrix[line] = (double*) malloc (DIMENSION * sizeof(double));
	}
	return matrix;
}

void fill_matrix(double **matrix){
	int line, column;
	for (line = 0; line < DIMENSION; line++) {
		for (column = 0; column < DIMENSION; column++) {
			matrix[line][column] = radom();
		}
	}
}

void initialize(int argc, char *argv[]){	
	size = 2;
	if (argc == 2){
		size = atoi(argv[1]);
		if (size > (DIMENSION * DIMENSION))
			size  = (DIMENSION * DIMENSION);
	}
		
	range = (DIMENSION * DIMENSION / size);

	srand(time(NULL));

	matrixA = create_matrix();
	matrixB = create_matrix();
	matrixProduct = create_matrix();
	
	fill_matrix(matrixA);
	fill_matrix(matrixB);
}

void print_matrix(double **matrix){
	int i, j;
	for (i = 0; i < DIMENSION; i++) {
		printf("\n");
		for (j = 0; j < DIMENSION; j++)
			printf("%9.2f", matrix[i][j]);
	}
	printf("\n"); 
}

double scalar_product(double *line, double *column){
	int i;
	double total;
	total = 0.0;
	for (i = 0; i < DIMENSION; i++){
		total += line[i] * column[i];
	}
	return total;
}